//+------------------------------------------------------------------+
//|                                             Price_crosses_MA.mq4 |
//|                                                 made by helloguy |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#define SHORT 111111
#define LONG 222222

extern int MA_Timeframe=0; //=PERIOD_M5, =PERIOD_M15, =PERIOD_D1, ect...
extern int MA_Period=20;
extern int MA_Shift=0;
extern int MA_AppPrice=4;
extern int MA_Method=0;
extern int MA_IndexShift=0;
extern double Lots=0.01;
extern int TakeProfit=0;
extern int StopLoss=10;
extern int Slippage=3;
extern int MagicNum=314592;

int maxorder=1;
int OpenOrder=0;
int PrevBars;

int init()
{
   PrevBars=Bars;
   return(0);
}

int start()
{
   if (Bars>PrevBars)
   {
      double SL,TP,P;
      int ot=OrdersTotal();
      
      // Open (first) Long Order
      if(Direction()==LONG && ot==0)
      {
         if (StopLoss != 0) SL=Ask-StopLoss*Point;
         else SL=0;
         if (TakeProfit != 0) TP=Ask+TakeProfit*Point;
         else TP=0;
         OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP,NULL,MagicNum,0,Blue);
         OpenOrder=LONG;
      }
      // Close short order and open long order
      if(Direction()==LONG && ot==1 && OpenOrder==SHORT)
      {
         OrderSelect(0,SELECT_BY_POS);
         {
            OrderClose(OrderTicket(),Lots,Ask,Slippage,CLR_NONE);
         }
         if (StopLoss != 0) SL=Ask-StopLoss*Point;
         else SL=0;
         if (TakeProfit != 0) TP=Ask+TakeProfit*Point;
         else TP=0;
         OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP,NULL,MagicNum,0,Blue);
         OpenOrder=LONG;
      }
      // Open (first) Short Order
      if (Direction()==SHORT && ot==0)
      {
         if (StopLoss != 0) SL=Bid+StopLoss*Point;
         else SL=0;
         if (TakeProfit != 0) TP=Bid-TakeProfit*Point;
         else TP=0;
         OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP,NULL,MagicNum,0,Red);
         OpenOrder=SHORT;
      }
      if (Direction()==SHORT && ot==1 && OpenOrder==LONG)
      {
         OrderSelect(0,SELECT_BY_POS);
         {
            OrderClose(OrderTicket(),Lots,Ask,Slippage,CLR_NONE);
         }
         if (StopLoss != 0) SL=Bid+StopLoss*Point;
         else SL=0;
         if (TakeProfit != 0) TP=Bid-TakeProfit*Point;
         else TP=0;
         OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP,NULL,MagicNum,0,Red);
         OpenOrder=SHORT;
      }
   }
   PrevBars=Bars;
   return(0);
}

//+------------------------------------------------------------------+
int Direction()
{
   if (Ask>iMA(NULL,MA_Timeframe,MA_Period,MA_Shift,MA_Method,MA_AppPrice,MA_IndexShift))
      return(LONG);
   else if (Bid<iMA(NULL,MA_Timeframe,MA_Period,MA_Shift,MA_Method,MA_AppPrice,MA_IndexShift))
      return(SHORT);
   else return(0);
}